/*!
  \file stdincl.h
  \brief This file includes default headers that nearly every Class needs.
  
  no Class is defined here, but many headers to classes, and more general Headers like the openGL-header.
*/

#ifndef _STDINCL_H
#define _STDINCL_H

#define null 0   //!< null

typedef unsigned char byte;

// this includes the information from configure/makefiles
#if HAVE_CONFIG_H 
#include <config.h> 
#endif

#ifdef __WIN32__
#include <windows.h>
#endif

#ifndef __APPLE__
#include <SDL/SDL.h>
#include <GL/gl.h>
#include <GL/glu.h>
#else
#include <SDL.h>
#include <OpenGL/gl.h>
#include <OpenGL/glu.h>
#endif

#include "vector.h"
#include "matrix.h"
#include "curve.h"
//#include "coordinates.h"
#include "list.h"
#include "list_template.h"
#include "error.h"
#include "debug.h"
#include "message_structures.h"
#include "orxonox.h"
#include "data_tank.h"
#include "base_object.h"

#endif /* _STDINCL_H */
