

/* 
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2004 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   ### File Specific:
   main-programmer: Christian Meyer
   co-programmer: ...
*/

#include "track.h"

using namespace std;

/**
   \brief creates a null Track part
*/
Track::Track ()
{
  this->ID = 0;
  this->offset = NULL;
  this->end = NULL;
  this->nextID = 0;
  this->setClassName ("Track");
}

/**
   \brief creates a functional base Track part
   \param number: the ID if this Track part
   \param next: the ID of the next Track part
   \param start: pointer to an anchor point (Vector) representing the offset of this part
   \param finish: pointer to an anchor point (Vector) representing the end of this part
*/
Track::Track (Uint32 number, Uint32 next, Vector* start, Vector* finish)
{
  this->ID = number;
  this->offset = start;
  this->end = finish;
  this->nextID = next;
  this->setClassName ("Track");
}

/**
   \brief removes the Track part from memory
*/
Track::~Track ()
{
}

void Track::init()
{
  
}





/**
   \brief this is called when a WorldEntity enters a Track part
   \param entity: pointer to the WorldEntity in question
   
   You can do stuff like add or remove effects, do some coordinate finetuning 
   or whatever in here.
*/
void Track::postEnter (WorldEntity* entity)
{
}


/**
   \brief this is called when a WorldEntity leaves a Track part
   \param entity: pointer to the WorldEntity in question
   
   You can do stuff like add or remove effects, do some coordinate finetuning 
   or whatever in here.
*/
void Track::postLeave (WorldEntity* entity)
{
}


/**
   \brief this is called every frame
   \param deltaT: amount of time passed since the last frame in seconds
   
   Do time based or polling scripts here. 
*/
void Track::tick (float deltaT)
{
}





